﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using XSharper.Core;

namespace Embed
{
    class Program
    {
        static void Main(string[] args)
        {
            ScriptContext context=new ScriptContext();

            using (var console=new ConsoleWithColors())
            using (var scope = new ScriptContextScope(context))
            {
                context.Output = console.OnOutput;
                context.Progress = context.Progress;

                var script=context.CreateNewScript("test.xsh");
                script.Load(@"
                        <print>Hello, world</print>
                        <return>Test</return>
                ");

                console.WriteLine("Return value: {0}",Dump.ToDump(context.ExecuteScript(script,null)));

            }
        }
    }
}
